"use strict";
Components.utils.import("resource://gre/modules/Services.jsm");

var mailmerge = {
	
	init: function(event) {
		
		event.stopPropagation();
		
		/* addressinvalid start */
		Recipients2CompFields();
		if(gMsgCompose.compFields.to == "") {
			
			try {
				
				/* Thunderbird 31 */
				Services.prompt.alert(window, getComposeBundle().getString("addressInvalidTitle"), getComposeBundle().getString("12511"));
				return;
				
			} catch(e) {
			}
			
			try {
				
				/* Thunderbird 38 */
				Services.prompt.alert(window, getComposeBundle().getString("addressInvalidTitle"), getComposeBundle().getString("noRecipients"));
				return;
				
			} catch(e) {
			}
			
		}
		/* addressinvalid end */
		
		/* subjectempty start */
		var subject = GetMsgSubjectElement().value;
		if(subject == "") {
			
			var flags = (Services.prompt.BUTTON_TITLE_IS_STRING * Services.prompt.BUTTON_POS_0) + (Services.prompt.BUTTON_TITLE_IS_STRING * Services.prompt.BUTTON_POS_1);
			
			if(Services.prompt.confirmEx(
				window,
				getComposeBundle().getString("subjectEmptyTitle"),
				getComposeBundle().getString("subjectEmptyMessage"),
				flags,
				getComposeBundle().getString("sendWithEmptySubjectButton"),
				getComposeBundle().getString("cancelSendingButton"),
				null, null, {value:0}) == 1)
			{
				return;
			}
			
		}
		/* subjectempty end */
		
		/* attachmentreminder start */
		if(gManualAttachmentReminder || (getPref("mail.compose.attachment_reminder_aggressive") && document.getElementById("attachmentNotificationBox").getNotificationWithValue("attachmentReminder"))) {
			
			var flags = (Services.prompt.BUTTON_TITLE_IS_STRING * Services.prompt.BUTTON_POS_0) + (Services.prompt.BUTTON_TITLE_IS_STRING * Services.prompt.BUTTON_POS_1);
			
			if(Services.prompt.confirmEx(
				window,
				getComposeBundle().getString("attachmentReminderTitle"),
				getComposeBundle().getString("attachmentReminderMsg"),
				flags,
				getComposeBundle().getString("attachmentReminderFalseAlarm"),
				getComposeBundle().getString("attachmentReminderYesIForgot"),
				null, null, {value:0}) == 1)
			{
				return;
			}
			
		}
		/* attachmentreminder end */
		
		/* spellcheck start */
		if(getPref("mail.SpellCheckBeforeSend")) {
			
			SetMsgBodyFrameFocus();
			
			window.cancelSendMessage = false;
			window.openDialog("chrome://editor/content/EdSpellCheck.xul", "_blank", "dialog,close,titlebar,modal,resizable", true, true, false);
			if(window.cancelSendMessage) { return; }
			
		}
		/* spellcheck end */
		
		/* dialog start */
		var params = { accept: false }
		window.openDialog("chrome://mailmerge/content/dialog.xul", "_blank", "chrome,dialog,modal,centerscreen", params);
		if(params.accept) {
			
			if(window.Enigmail) {
				
				var identity = getCurrentIdentity();
				var autoencryptdrafts = identity.getBoolAttribute("autoEncryptDrafts");
				
				identity.setBoolAttribute("autoEncryptDrafts", false);
				SaveAsTemplate();
				identity.setBoolAttribute("autoEncryptDrafts", autoencryptdrafts);
				
			}
			else {
				
				SaveAsTemplate();
				
			}
			
			mailmerge.editor = gMsgCompose.editor.outputToString("text/html", 4);
			window.setTimeout(function() { mailmerge.compose(); }, 1000);
			
		}
		/* dialog end */
		
	},
	
	compose: function() {
		
		/* Thunderbird */
		if(Services.appinfo.ID == "{3550f703-e582-4d05-9a08-453d09bdfdc6}") {
			if(gSendOperationInProgress || gSaveOperationInProgress) { window.setTimeout(function() { mailmerge.compose(); }, 1000); return; }
		}
		
		/* SeaMonkey */
		if(Services.appinfo.ID == "{92650c4d-4b8e-4d2a-b7eb-24ecf4f6b63a}") {
			if(gSendOrSaveOperationInProgress) { window.setTimeout(function() { mailmerge.compose(); }, 1000); return; }
		}
		
		window.openDialog("chrome://mailmerge/content/compose.xul", "_blank", "chrome,dialog,modal,centerscreen", null);
		window.close();
		
	}
	
}
